{
TLC549A
Odczyt napiecia z przetwornika TLC549, impulsy zegarowe na linii TxD sa
generowane przez nadajnik UART - wysylajac znak "U"

autor:  Grzegorz P.
grzegorz.podgorski@wp.pl
http://www.w.cz.prv.pl
}

uses dos,keyboard;

const
 MSR=6;
 MCR=4;
 IER=1;
 IIR=2;

 DTR=1;
 RTS=2;
 TxD=64;
 DCD=128;
 CTS=16;
 Out2=8;

 ClockBit=DCD; { DCD<=TxD }
 ChipSelect=DTR;
 DataOut=CTS;
 Vcc=RTS+Out2;

 REF=2.48;{Napiecie odniesienia}
 Licznik:byte=8;
 AD:byte=0;
 f:word=110;{Domyslna czestotliwosc zegara taktujacego}
 WskPostepu:char='/';

var
 adr,freq,i:word;
 ComInt,ComIntMask:byte; {Nr przerw i jego maska w PIC}
 s:string;
 oldInt:pointer;


procedure Blad;
var i:word;
begin
 writeln;
 writeln('TLC549A par1 [par2]');
 writeln('Odczyt napiecia z przetwornika TLC549, impulsy zegarowe sa generowane');
 writeln('przez nadajnik UART - wysylanie znaku "U"');
 writeln('par1 - numer portu');
 writeln('par2 - czestotliwosc probkowania');
 writeln('Dopuszczalne wartosci czestotliwosci probkowania:');
 for i:=1 to (57600 div 9) do if (57600 div 9) mod i=0 then write(i,',');
 writeln(#8'.');
 halt;
end;

procedure JestWynikAD;
begin
 write(AD*REF/256:4:2,WskPostepu,#8#8#8#8#8);
 case WskPostepu of
 '/':WskPostepu:='|';
 '|':WskPostepu:='\';
 '\':WskPostepu:='/';
 end;
end;


{$F+}
procedure ComHandler;interrupt;
begin
 if port[adr+MSR] and ClockBit>0 then
 begin
  if licznik=8 then port[adr+MCR]:=Vcc+ChipSelect
  else begin
   port[adr+MCR]:=Vcc;
   if (port[adr+MSR] and DataOut)>0 then inc(AD,1 shl licznik);
  end;
  if licznik>0 then dec(Licznik) else
  begin {Licznik=0 - Odczytana cala wartosc z przetw.
          - wywolanie procedury odbierajacej dane}
   JestWynikAD;
   licznik:=8;
   AD:=0;
  end;
 end;
 port[$20]:=$20;
end;
{$F-}


begin
 s:=ParamStr(1);
 case s[1] of
 '1':begin
      adr:=$3f8;
      ComInt:=$0C;
      ComIntMask:=$10;
     end;
 '2':begin
      adr:=$2f8;
      ComInt:=$0B;
      ComIntMask:=$08;
     end;
  else blad;
 end;

 if ParamCount=2 then
  begin
   val (ParamStr(2),freq,i);
   if i>0 then blad;
   if freq>(57600 div 9) then blad;
   if (57600 div 9) mod freq<>0 then blad;
   f:=freq*9;
  end;

  {Ustalenie parametrow transmisji}
 port[adr + 3]:=port[adr + 3] OR 128;
 port[adr + 1]:=hi(115200 div f div 2);
 port[adr]:=lo(115200 div f div 2);
 port[adr + 3]:=port[adr + 3] AND NOT 128;
 port[adr + 3]:=3 OR 0 OR 0;

 {===Zaprogramowanie UARTa, zeby zmiana stanu linii modemowych lub
  niedopenienie buf powodowolalo wywolanie przerwania===}

 asm sti end; {Zablokuj wszystkie przerwan}
 GetIntVec(ComInt,oldInt); {Zapamietaj stary i ustaw nowa procedure obslugi przerwania}
 SetIntVec(ComInt,@ComHandler);
 port[$21]:=port[$21]and (not ComIntMask); {Wlacz obslue przerwania}
 port[adr+IER]:=8; {Zrodlo zdarzen - zmiana stanu linii modemowych}
 port[adr+MCR]:=12;{Wlacz obsluge zdarzen w UART- ustaw out2 i ustaw dtr+rts}
 asm sti end; {Odblokuj przerwania}



 Writeln(#10#13'Pomiar napiecia');
 writeln('Nacisnij dowolny klawisz aby zakonczyc');
 write('Mierzone napiecie [V]=');
 repeat
  repeat until port[adr+5] and $20>0; {Doladowywanie bufora znakiem 'U'}
  port[adr]:=ord('U');
 until keypressed;


 {Przywrocenie dla rejestrow UART wartosci domyslnych}
 asm cli end;
 port[adr+IER]:=0;
 port[adr+MCR]:=0;
 port[$21]:=port[$21] or ComIntMask;
 SetIntVec(ComInt,oldInt);
 asm sti end;

end.