{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,R-,S-,V-,X-}
{$M 16384,0,0}
{autor Grzegorz P.}
{grzegorz.podgorski@wp.pl}

unit tmr;
interface

const
 licznik8h:word=0;{zliczona ilosc wywolan int8h}
 ff:word=10000; {czest wyzwalania int8h}
 pomiar:real=0;{wynik pomiaru po "stopie"}
 pomiarTrwa:boolean=false;

var
 Int8:pointer; {adres newInt8h}

 procedure zabron; {int8h}
 procedure zezwol; {int8h}
 procedure start1; {start timer int8h}
 procedure stop1;  {stop timer int8h}
 procedure start2; {start inny timer}
 procedure stop2;  {stop inny timer}
 procedure calibrate {kalibracja inny timer};
 procedure setFF; {ustalenie czest wyzwalania int8h}
 procedure startINT(p:pointer);{start int8 na procedure obslugi pod adresem p (wlasna)}
 procedure stopINT;{stop int8 na wlasna procedure}
implementation


uses dos;

var
 old8h:pointer;

const
 fq=1193180.666;

procedure zezwol;assembler;
 asm
  in al,21h
  and al,$fe
  out 21h,al
end;

procedure zabron;assembler;
 asm
  in al,21h
  or al,1
  out 21h,al
end;

procedure zegar(f:word);
begin
 port[$43]:=$34;
 port[$40]:=lo(f);
 port[$40]:=hi(f);
end;

{$F+}
procedure new8h;interrupt;
begin
 inc(licznik8h);
 port[$20]:=$20;
end;
{$F-}

procedure start1;
begin
  zegar(trunc(fq/ff));
  getintvec(8,old8h);
  zabron;
  licznik8h:=0;
  setintvec(8,@new8h);
  zezwol;
  pomiarTrwa:=true;
end;

procedure stop1;
begin
  zabron;
  setintvec(8,old8h);
  zegar(0);
  zezwol;
  pomiar:=licznik8h/ff;
  pomiarTrwa:=false;
end;

procedure setFF;
begin
 zabron;
 zegar(trunc(fq/ff));
 zezwol;
end;

procedure startint(p:pointer);
begin
  zegar(trunc(fq/ff));
  getintvec(8,old8h);
  zabron;
  setintvec(8,p);
  zezwol;
end;

procedure stopint;
begin
  zabron;
  setintvec(8,old8h);
  zegar(0);
  zezwol;
end;

var
 dos_time:longint absolute $40:$6c;
 start_time:longint;
 w:word;

const
 time_per_count=0.838097E-6;
 adjust:word=0;

procedure start2;
begin
 pomiarTrwa:=true;
 asm
  mov al,$34
  out $43,al
  sub ax,ax
  out $40,al
  out $40,al
 end;
 start_time:=dos_time;
end;

procedure get_time(var count:word;var time:longint);
var c:word;
begin
 asm
  mov al,0
  out $43,al
  in al,$40
  mov dl,al
  in al,$40
  mov dh,al
  mov c,dx
 end;
 count:=c;
 time:=dos_time;
end;

procedure stop2;
var count:word;
    stop_time:longint;
begin
 pomiarTrwa:=false;
 get_time(count,stop_time);
 pomiar:=time_per_count*((65536-count-adjust)+65536*(stop_time-start_time));
end;

procedure calibrate;
var i,sum:word;
    time:real;
begin
 adjust:=0;
 sum:=0;
 for i:=1 to 10 do begin
  start2;
  stop2;
  sum:=sum+round(pomiar/time_per_count);
 end;
 adjust:=(sum+5)div 10;
end;

begin
 Int8:=@new8h;
end.
